// Header File
// !!! Do not Include this file !!!
// Created 04/07/2006; 18:43:13

/**
 * This procedure draw a line on the (virtual) screen.
 * This implements the bresenham algorithm, but it is actually slower than the graphlib... :-(
 */
static /* inline */ void CriDrawLine (const Screen * screen,
																			long x1 asm ("d0"), long y1 asm ("d1"),
																			long x2 asm ("d2"), long y2 asm ("d3")) {
	void * screen_buffer ;
	screen_buffer = screen->address ;
	asm volatile ("
cri_draw_line:
	move.w	#0x5240,%%d4			/* What are these constants */
	move.w	#0x5241,%%d5
	sub.w		%%d0,%%d2
	bpl.w		not_neg
	neg.w		%%d2
	move.w	#0x5340,%%d4
not_neg:
	sub.w		%%d1,%%d3
	bpl.w		not_neg2
	neg.w		%%d3
	move.w	#0x5341,%%d5
not_neg2:
	move.w	%%d2,%%d6
	or.w		%%d3,%%d6
	bne.w		line_exists
	rts
line_exists:
	lea			L000,%%a1
	move.w	%%d4,(%%a1)+
	move.w	%%d5,(%%a1)
	cmp.w		%%d3,%%d2
	bge.w		L061
	exg.l		%%d3,%%d2
	move.w	#0x4E71,%%d4
	jmp			L001
L061:
	move.w	#0x4E71,%%d5
L001:
	lea			L002,%%a1
	move.w	%%d4,(%%a1)+
	move.w	%%d5,(%%a1)
	move.w	%%d3,%%d6
	asl.w		#1,%%d6
	move.w	%%d6,%%d5
	sub.w		%%d2,%%d6
	move.w	%%d6,%%d4
	sub.w		%%d2,%%d4
L080:
	cmpi.w	#0xA0,%%d0
	bge.w		L07F
	cmpi.w	#0x64,%%d1
	bge.w		L07F
	move.l	%[screen_buffer],%%a1
	move.w	%%d1,%%d7
	bmi.w		L07F
	ext.l		%%d7
	move.l	%%d7,%%d3
	asl.l		#5,%%d7
	asl.l		#1,%%d3
	sub.l		%%d3,%%d7
	move.w	%%d0,%%d3
	bmi.w		L07F
	asr.w		#3,%%d3
	ext.l		%%d3
	add.l		%%d3,%%d7
	adda.l	%%d7,%%a1
	move.b	%%d0,%%d7
	not.b		%%d7
	bset		%%d7,(%%a1)
L07F:
	tst.w		%%d6
	bpl.w		L000
L002:
	nop							/* Automodifiable code */
	nop
	add.w		%%d5,%%d6
	subq.w	#1,%%d2
	bne.s		L080
	jmp	end_cri_draw_line
L000:
	nop							/* Automodifiable code */
	nop
	add.w		%%d4,%%d6
	subq.w	#1,%%d2
	bne.s		L080
end_cri_draw_line:
	rts
	"
	:
	: [screen_buffer] "m" (screen_buffer), [x1] "g" (x1), [y1] "g" (y1), [x2] "g" (x2), [y2] "g" (y2)) ;
}


static void SimpleFillPolygon (const Screen * screen, short nb, Coordinate coords []) {
	int i ;
	if (nb < 3) return ;
	// Configure graph lib
	PortSet (screen->address, 239, 127) ;
	// Split polygon into triangles
	for (i = 1; i < nb -1 ; i++) {
		// Clear area
		FillTriangle (coords[0].x, coords[0].y,
			coords[i].x, coords[i].y,
			coords[i+1].x, coords[i+1].y,
			&(SCR_RECT){{0,0, screen->width, screen->height}}, A_REVERSE) ;
		// Draw borders
		DrawClipLine (&(WIN_RECT){coords[i].x, coords[i].y, coords[i+1].x, coords [i+1].y},
			&(SCR_RECT){{0,0,screen->width, screen->height}},
			A_NORMAL) ;
	}
	// Draw the first line
	DrawClipLine (&(WIN_RECT){coords[0].x, coords[0].y, coords[1].x, coords [1].y},
		&(SCR_RECT){{0,0,screen->width, screen->height}},
		A_NORMAL) ;
	// Draw the last line
	DrawClipLine (&(WIN_RECT){coords[0].x, coords[0].y, coords[nb-1].x, coords [nb-1].y},
		&(SCR_RECT){{0,0,screen->width, screen->height}},
		A_NORMAL) ;
}
