// Header File
// !!! Do not Include this file !!!
// Created 19/06/2006; 20:20:51

void DrawPolygon (const Screen * screen, short nb, Coordinate coords []) {
	int i ;
	// Draw the first line
	DrawClipLine (&(WIN_RECT){coords[0].x, coords[0].y, coords[1].x, coords [1].y},
		&(SCR_RECT){{0,0,screen->width, screen->height}},
		A_NORMAL) ;
	for (i = 1; i < nb -1 ; i++) {
		// Draw borders
		DrawClipLine (&(WIN_RECT){coords[i].x, coords[i].y, coords[i+1].x, coords [i+1].y},
			&(SCR_RECT){{0,0,screen->width, screen->height}},
			A_NORMAL) ;
	}
	// Draw the last line
	DrawClipLine (&(WIN_RECT){coords[0].x, coords[0].y, coords[nb-1].x, coords [nb-1].y},
		&(SCR_RECT){{0,0,screen->width, screen->height}},
		A_NORMAL) ;
}

void FillPolygon (const Screen * screen, short nb, Coordinate coords []) {
	void * screen_cursor ; /* L005 */
	void * screen_buffer ;
	short y_min, y_max ;
	void * L00B ;
	void * L008 ;
	short L013, L015, L016, L01C, L01D ;
	//void * screen_buffer ;
	screen_buffer = screen->address ;
	/* L006: */
	// Fill polygon
	asm volatile ("
	move.l	%[screen_buffer],%[screen_cursor]
	move.l	%[coords],%%a4
	move.w	%[nb],%%d7
	move.l	%%a4,%%a2
	# L008 <=> coords
	move.l	%%a4,%[L008]
	# L009 <=> y_min
	move.w	2(%%a4),%[y_min]
	# L00A	<=> lower point
	move.w	2(%%a4),%[y_max] 
	lea			4(%%a4),%%a4
init_upper_y_max:
	subq.w	#1,%%d7
	beq.w		end_init
	move.l	(%%a4)+,%%d0		
	cmp.w		%[y_min],%%d0
	ble.w		not_y_min
	move.w	%%d0,%[y_min]
not_y_min:
	cmp.w		%[y_max],%%d0			
	bge.s		init_upper_y_max			
	move.w	%%d0,%[y_max]			
	lea			-4(%%a4),%%a2
	jmp			init_upper_y_max		
end_init:
	lea			-4(%%a4),%%a4
	move.l	%%a4,%[L00B]
	move.w	%[y_min],%%d0
	cmp.w		%[y_max],%%d0
	beq.w		draw_borders			
	movea.l	%%a2,%%a3
	cmpi.w	#0,%[y_min]
	blt.w		draw_borders
	move.w	%[y_max],%%d0
	cmp.w		%[lcd_height],%%d0
	bgt.w		draw_borders
	moveq.l	#0,%%d0
	move.w	%[y_max],%%d0
	move.w	%%d0,%[L013]
	tst.w		%[L013]
	bmi.w		L07B
	move.l	%%d0,%%d1			
	asl.l		#5,%%d0
	asl.l		#1,%%d1			
	sub.l		%%d1,%%d0			
	add.l		%%d0,%[screen_cursor]			
	addi.l	#30,%[screen_cursor]		
L07B:
	move.w	%[lcd_height],%%d0
	cmp.w		%[y_min],%%d0
	bgt.w		L07C
	subq.l	#1,%%d0
	move.w	%%d0,%[y_min]
L07C:
	subq.w	#1,%[y_min]
L097:
	addq.w	#1,%[L013]
	move.w	2(%%a2),%%d0
	cmp.w		%[L013],%%d0			
	bgt.w		L07D
L088:
	movea.l	%%a2,%%a4			
	cmpa.l	%[L00B],%%a2			
	beq.w		L07E
	lea			4(%%a2),%%a2
	jmp			L021
L07E:
	movea.l	%[L008],%%a2			
L021:
	move.w	2(%%a4),%%d1		
	sub.w		2(%%a2),%%d1		
	beq.s		L088			
	move.w	(%%a4),%%d0			
	asl.w		#7,%%d0			
	move.w	%%d0,%[L015]			
	move.w	%%d1,%%d2			
	moveq.l	#0,%%d0			
	move.w	(%%a4),%%d0			
	sub.w		(%%a2),%%d0			
	tst.w		%%d0
	bpl.w		L089
	neg.w		%%d0
	neg.w		%%d1
L089:
	asl.l		#7,%%d0
	# dc.w		0x81C1			Illegal
	divs.w	%%d1,%%d1
	move.w	%%d0,%[L016]
L07D:
	move.w	%[L016],%%d0			
	add.w		%%d0,%[L015]
	move.w	2(%%a3),%%d0
	cmp.w		%[L013],%%d0
	bgt.w		L086
L093:
	movea.l	%%a3,%%a5			
	cmpa.l	%[L008],%%a3			
	beq.w		L087
	lea			-4(%%a3),%%a3		
	jmp			L022
L087:
	movea.l	%[L00B],%%a3			
L022:
	move.w	2(%%a5),%%d1		
	sub.w		2(%%a3),%%d1		
	beq.s		L093			
	move.w	(%%a5),%%d0			
	asl.w		#7,%%d0			
	move.w	%%d0,%[L01C]
	move.w	%%d1,%%d2			
	moveq.l	#0,%%d0			
	move.w	(%%a5),%%d0			
	sub.w		(%%a3),%%d0			
	tst.w		%%d0			
	bpl.w		L094			
	neg.w		%%d0
	neg.w		%%d1
L094:
	asl.l		#7,%%d0
	#	dc.w		0x81C1   Illegal
	divs.w	%%d1,%%d0
	move.w	%%d0,%[L01D]
L086:
	move.w	%[L01D],%%d0			
	add.w		%%d0,%[L01C]
	move.w	%[y_min],%%d0			
	cmp.w		%[L013],%%d0
	ble.w		draw_borders
	tst.w		%[L013]
	bmi.w		L08D
	move.w	%[L015],%%d2			
	asr.w		#7,%%d2
	cmp.w		%[lcd_width],%%d2	
	bge.w		L08E
	move.w	%[L01C],%%d3			
	asr.w		#7,%%d3
	bmi.w		L08E			
	moveq.l	#0,%%d7			
	move.w	%%d3,%%d7			
	sub.w		%%d2,%%d7			
	beq.w		L08E
	bmi.w		end_draw_polygon			
	tst.w		%%d2			
	bpl.w		L08F			
	move.w	%%d3,%%d7			
	clr.w		%%d2
L08F:
	movea.l	%[screen_cursor],%%a1			
	moveq.l	#0,%%d0			
	move.w	%%d2,%%d0			
	asr.w		#3,%%d0			
	adda.l	%%d0,%%a1			
	move.b	%%d2,%%d6			
	not.b		%%d6
	andi.b	#7,%%d6
	# Usefull ?
	moveq.l #0,%%d0
	move.l	%[lcd_width],%%d0	
	cmp.w		%%d7,%%d0			
	bgt.w		L090			
	subq.w	#1,%%d0			
	move.w	%%d0,%%d7			
L090:
	move.b	(%%a1),%%d1			
L092:
	bclr		%%d6,%%d1			
	subq.b	#1,%%d6			
	bpl.w		L091			
	move.b	%%d1,(%%a1)+		
	move.b	#7,%%d6
	move.b	(%%a1),%%d1			
	dbf			%%d7,L092			
	jmp			L023
L091:
	dbf			%%d7,L092			
L023:
	move.b	%%d1,(%%a1)			
L08E:
	addi.l	#30,%[screen_cursor]		
L08D:
	jmp	L097

draw_borders:
	"
	:
	: [screen_buffer] "m" (screen_buffer), [screen_cursor] "m" (screen_cursor),
		[nb] "g" (nb), [coords] "m" (coords),
		[y_max] "g" (y_max), [y_min] "g" (y_min),
		[lcd_height] "g" (LCD_HEIGHT),[lcd_width] "g" (LCD_WIDTH),
		[L008] "m" (L008), 
		[L00B] "m" (L00B), [L013] "g" (L013), [L015] "g" (L015), [L016] "g" (L016), [L01C] "g" (L01C), [L01D] "g" (L01D)) ;
	// Draw borders:
	DrawPolygon (screen, nb, coords) ;
	// End of draw texture
	asm volatile ("
end_draw_polygon:
	" ::) ;
}
