// Header File
// !!! Do not Include this file !!!
// Created 20/06/2006; 13:47:15

/* Internal variable for textures */
static short lcd_height, lcd_width ;
static short y_max, y_min ;
static short mpoints [] ;
static long picturew ;
static short coords [7] = {3,0,0,0,0,0,0} ;
static short mcoords [6] = {0,0,0,0,0,0} ;
static void * last_point ;
static void * first_point ;
static long L00F, L010, L011, L012, L013, L015, L016, L017, L018 ;
static long L019, L01A, L01C, L01D ;
static void * texture ;
static void * screen_cursor ;
static char unique_access_to_fill_triangle_with_texture = FALSE ;

void FillTriangleWithTexture (const Screen * screen, const Texture * t,
															const Coordinate * c0, const Coordinate * map0,
															const Coordinate * c1, const Coordinate * map1,
															const Coordinate * c2, const Coordinate * map2) {
	void * screen_buffer ;
	if (unique_access_to_fill_triangle_with_texture) return ;
	unique_access_to_fill_triangle_with_texture = TRUE ;
	if (t->width > 128) return ;
	coords [0] = 3 ; // already made in initialization
	coords [1] = c0->x ;
	coords [2] = c0->y ;
	coords [3] = c1->x ;
	coords [4] = c1->y ;
	coords [5] = c2->x ;
	coords [6] = c2->y ;
	mcoords [0] = map0->x ;
	mcoords [1] = map0->y ;
	mcoords [2] = map1->x ;
	mcoords [3] = map1->y ;
	mcoords [4] = map2->x ;
	mcoords [5] = map2->y ;
	texture = t->data ;
	if (texture == NULL) return ;
	picturew = t->width ;
	screen_buffer = screen->address ;
	lcd_width = screen->width ;
	lcd_height = screen->height ;

	asm volatile ("
	movem.l	%%a6,-(%%a7)											/* a6 is used for the purpose of the function */
	move.l	%[screen_buffer],screen_cursor								/* Inutile ? screen_cursor */
	# Is that correct to replace LEA to MOVE ?
	lea			coords,%%a4
	move.w	(%%a4)+,%%d7
	# LEA replaced into MOVE
	lea			mcoords,%%a6
	suba.w	%%a4,%%a6
	movea.l	%%a4,%%a2
	# first_point <=> (coords + 1)
	move.l	%%a4,first_point
	# L009 <=> y_min
	move.w	2(%%a4),y_min
	# L00A	<=> y_max
	move.w	2(%%a4),y_max 
	lea			4(%%a4),%%a4

init_y_min_max_texture: /* L079: */
	subq.w	#1,%%d7
	beq.w		end_init_texture
	# Get the minimum Y value of all points
	move.l	(%%a4)+,%%d0
	cmp.w		y_min,%%d0
	ble.w		not_y_min_texture
	move.w	%%d0,y_min									/* y_min: max_y */
not_y_min_texture:
	# Get the maximum Y value, and put it into y_max
	cmp.w		y_max,%%d0
	bge.s		init_y_min_max_texture			
	move.w	%%d0,y_max
	# a2 points on the y max (point at the bottom)
	lea			-4(%%a4),%%a2
	jmp			init_y_min_max_texture		
end_init_texture:
	lea			-4(%%a4),%%a4
	move.l	%%a4,last_point
	# If the y_min is negative there is nothing to draw
	cmpi.w	#0,y_min
	blt.w		end_draw_texture
	# The same for the y_max
	move.w	y_max,%%d0
	cmp.w		lcd_height,%%d0
	bgt.w		end_draw_texture

	# a2 <=> y max
	movea.l	%%a2,%%a3
	movea.l	%%a2,%%a4
	cmpa.l	last_point,%%a2
	beq.w		L083
	lea			4(%%a2),%%a2
	jmp			L00C
L083:
	 # LEA or MOVE ?
	move.l		first_point,%%a2
L00C:
	# cmpa.l	coords+1,%%a3 Replaced into:
	# cmpa.l	%%a2,%%a3 wrong
	cmpa.l	first_point,%%a3

	beq.w		L08B
	lea			-4(%%a3),%%a3
	jmp			L00D
L08B:
	movea.l	last_point,%%a3
L00D:
	# Now a4 should point on the y max
	moveq.l	#0,%%d2
	moveq.l	#0,%%d3
	moveq.l	#0,%%d4
	moveq.l	#0,%%d5
	move.w	2(%%a2),%%d4
	sub.w		2(%%a4),%%d4
	move.w	2(%%a3),%%d5							/* Valeur de D5 chelou */
	sub.w		2(%%a4),%%d5

	cmp.w		%%d4,%%d5
	beq.w		L095
	bgt.w		L096
	asl.l		#8,%%d5
	divu.w	%%d4,%%d5
	andi.l	#0xFFFF,%%d5
	move.w	0(%%a3,%%a6.w),%%d2
	sub.w		0(%%a4,%%a6.w),%%d2
	asl.w		#8,%%d2
	move.w	0(%%a2,%%a6.w),%%d0
	sub.w		0(%%a4,%%a6.w),%%d0
	muls.w	%%d5,%%d0
	sub.w		%%d0,%%d2
	move.w	2(%%a3,%%a6.w),%%d3
	sub.w		2(%%a4,%%a6.w),%%d3
	asl.w		#8,%%d3
	move.w	2(%%a2,%%a6.w),%%d0
	sub.w		2(%%a4,%%a6.w),%%d0
	muls.w	%%d5,%%d0
	sub.w		%%d0,%%d3
	moveq.l	#0,%%d1
	move.w	(%%a2),%%d1
	sub.w		(%%a4),%%d1
	muls.w	%%d5,%%d1
	asr.l		#8,%%d1
	add.w		(%%a4),%%d1
	sub.w		(%%a3),%%d1
	neg.w		%%d1
	jmp			L00E
L096:
	asl.l		#8,%%d4
	divu.w	%%d5,%%d4
	move.w	0(%%a3,%%a6.w),%%d2
	sub.w		0(%%a4,%%a6.w),%%d2
	muls.w	%%d4,%%d2
	move.w	0(%%a4,%%a6.w),%%d0
	sub.w		0(%%a2,%%a6.w),%%d0
	asl.w		#8,%%d0
	add.w		%%d0,%%d2
	move.w	2(%%a3,%%a6.w),%%d3
	sub.w		2(%%a4,%%a6.w),%%d3
	muls.w	%%d4,%%d3
	move.w	2(%%a4,%%a6.w),%%d0
	sub.w		2(%%a2,%%a6.w),%%d0
	asl.w		#8,%%d0
	add.w		%%d0,%%d3
	moveq.l	#0,%%d1
	move.w	(%%a3),%%d1
	sub.w		(%%a4),%%d1
	muls.w	%%d4,%%d1
	asr.l		#8,%%d1
	add.w		(%%a4),%%d1
	sub.w		(%%a2),%%d1
	jmp	L00E
L095:
	move.w	0(%%a3,%%a6.w),%%d2
	sub.w		0(%%a2,%%a6.w),%%d2
	asl.l		#8,%%d2
	move.w	2(%%a3,%%a6.w),%%d3
	sub.w		2(%%a2,%%a6.w),%%d3
	asl.l		#8,%%d3
	move.w	(%%a3),%%d1
	sub.w		(%%a2),%%d1
L00E:
	tst.w		%%d1
	bmi.w		end_draw_texture
	beq.w		end_draw_texture
	move.w	%%d1,-(%%a7)
	andi.l	#0xFFFF,%%d2
	tst.w		%%d2
	bpl.w		L098
	neg.w		%%d2
	neg.w		%%d1
L098:
	# Should be divs.w %%d1,%%d2
	#dc.w		0x85C1
	divs.w	%%d1,%%d2
	move.w	(%%a7)+,%%d1
	ext.l	%%d2
	move.l	%%d2,L00F
	move.w	%%d1,-(%%a7)
	andi.l	#0xFFFF,%%d3
	tst.w		%%d3
	bpl.w		L099
	neg.w		%%d3
	neg.w		%%d1
L099:
	# Should be divs.w %%d1,%%d3
	#dc.w		0x87C1
	divs.w	%%d1,%%d3
	move.w	(%%a7)+,%%d1
	ext.l		%%d3
	move.l	%%d3,L010
	move.b	%%d2,L011
	moveq.l	#0,%%d1
	move.b	%%d3,%%d1
	ror.l		#8,%%d1
	asr.w		#8,%%d2
	asr.w		#8,%%d3
	# picture width ?
	muls.w	picturew+2,%%d3
	add.w		%%d2,%%d3
	move.w	%%d3,%%d0
	ext.l		%%d0
	andi.l	#0xFFFFFF,%%d0
	or.l		%%d1,%%d0
	move.l	%%d0,L012
	movea.l	%%a4,%%a2
	movea.l	%%a4,%%a3
	moveq.l	#0,%%d0
	move.w	y_max,%%d0
	move.w	%%d0,L013
	tst.w		L013
	bmi.w		L09A
	move.l	%%d0,%%d1
	asl.l		#5,%%d0
	asl.l		#1,%%d1
	sub.l		%%d1,%%d0
	add.l		%%d0,screen_cursor
L09A:
	/*jmp L09A*/

	# Should not be usefull: moveq.l #0,%%d0
	move.w	lcd_height,%%d0
	cmp.w		y_min,%%d0
	bgt.w		draw_next_line_texture
	subq.l	#1,%%d0
	move.w	%%d0,y_min
draw_next_line_texture:							/* L09B: Main loop */
	#jmp draw_next_line_texture

	move.w	y_min,%%d0
	cmp.w		L013,%%d0
	ble.w		end_draw_texture
	move.w	2(%%a2),%%d0
	cmp.w		L013,%%d0
	bne.w		L09C
L0A0:
	movea.l	%%a2,%%a4
	cmpa.l	last_point,%%a2
	beq.w		L09D
	lea			4(%%a2),%%a2
	jmp			L014
L09D:
	# LEA or MOVE ?
	#lea			coords+2,%%a2
	move.l	first_point,%%a2
L014:
	move.w	2(%%a4),%%d1
	sub.w		2(%%a2),%%d1
	beq.s		L0A0
	move.w	(%%a4),%%d0
	asl.w		#7,%%d0
	move.w	%%d0,L015
	move.w	%%d1,%%d2
	moveq.l	#0,%%d0
	move.w	(%%a4),%%d0
	sub.w		(%%a2),%%d0
	tst.w		%%d0
	bpl.w		L0A1
	neg.w		%%d0
	neg.w		%%d1
L0A1:
	asl.l		#7,%%d0
	# dc.w		0x81C1 Illegal
	divs.w	%%d1,%%d0
	move.w	%%d0,L016
	moveq.l	#0,%%d0
	move.w	0(%%a4,%%a6.w),%%d0
	asl.l		#8,%%d0
	move.l	%%d0,L017
	move.w	2(%%a4,%%a6.w),%%d0
	asl.l		#8,%%d0
	move.l	%%d0,L018
	move.w	%%d2,%%d1
	moveq.l	#0,%%d0
	move.w	0(%%a4,%%a6.w),%%d0
	sub.w		0(%%a2,%%a6.w),%%d0
	tst.w		%%d0
	bpl.w		L0A2
	neg.w		%%d0
	neg.w		%%d1
L0A2:
	asl.l		#8,%%d0
	# dc.w		0x81C1 Illegal
	divs.w	%%d1,%%d0
	ext.l		%%d0
	move.l	%%d0,L019
	moveq.l	#0,%%d1
	move.w	2(%%a4,%%a6.w),%%d1
	sub.w		2(%%a2,%%a6.w),%%d1
	tst.w		%%d1
	bpl.w		L0A3
	neg.w		%%d1
	neg.w		%%d2
L0A3:
	asl.l		#8,%%d1
	# dc.w		0x83C2		Illegal
	divs.w	%%d2,%%d1
	ext.l		%%d1
	move.l	%%d1,L01A
L09C:
	move.w	2(%%a3),%%d0
	cmp.w		L013,%%d0
	bne.w		L09E
L0AB:
	movea.l	%%a3,%%a5
	# cmpa.l	coords+1,%%a3 crash, replaced with:
	# Is a2 correct here ?
	cmpa.l	first_point,%%a3
	beq.w		L09F
	lea			-4(%%a3),%%a3
	jmp			L01B
L09F:
	movea.l	last_point,%%a3
L01B:
	move.w	2(%%a5),%%d1
	sub.w		2(%%a3),%%d1
	beq.s		L0AB
	move.w	(%%a5),%%d0
	asl.w		#7,%%d0
	move.w	%%d0,L01C
	move.w	%%d1,%%d2
	moveq.l	#0,%%d0
	move.w	(%%a5),%%d0
	sub.w		(%%a3),%%d0
	tst.w		%%d0
	bpl.w		L0AC
	neg.w		%%d0
	neg.w		%%d1
L0AC:
	asl.l		#7,%%d0
	# dc.w		0x81C1		Illegal
	divs.w	%%d1,%%d0
	move.w	%%d0,L01D
L09E:
	tst.w		L013
	bmi.w		L0A4
	move.w	L015,%%d2
	asr.w		#7,%%d2
	cmp.w		lcd_width,%%d2
	bge.w		L0A5
	move.w	L01C,%%d3
	asr.w		#7,%%d3
	bmi.w		L0A5
	moveq.l	#0,%%d7
	move.w	%%d3,%%d7
	sub.w		%%d2,%%d7
	bmi.w		L0A5
	move.l	L017,%%d4
	move.l	L018,%%d5
	tst.w		%%d2
	bpl.w		L0A6
	move.w	%%d3,%%d7
	neg.w		%%d2
	move.l	L00F,%%d1
	muls.w	%%d2,%%d1
	add.l		%%d1,%%d4
	move.l	L010,%%d1
	muls.w	%%d2,%%d1
	add.l		%%d1,%%d5
	clr.w		%%d2
L0A6:
	# LEA or MOVE ?
	movea.l	screen_cursor,%%a1
	moveq.l	#0,%%d0
	move.w	%%d2,%%d0
	asr.w		#3,%%d0
	adda.l	%%d0,%%a1
	move.b	%%d2,%%d6
	not.b		%%d6
	andi.b	#7,%%d6
	# Added stuff
	moveq.l	#0,%%d0
	move.w	lcd_width,%%d0
	cmp.w		%%d7,%%d0
	bgt.w		L0A7
	subq.w	#1,%%d0
	move.w	%%d0,%%d7
L0A7:
	moveq.l	#0,%%d0
	move.b	%%d5,%%d0
	ror.l		#8,%%d0
	move.l	%%d4,%%d1
	asr.w		#8,%%d1
	asr.w		#8,%%d5
	# muls <=> Utiliser un dcalage de bits !!!
	# picture width !!!!
	muls.w	picturew+2,%%d5
	add.w		%%d1,%%d5
	add.l		%%d0,%%d5
	# LEA or MOVE ?
	move.l	texture,%%a0
	add.l		%%a0,%%d5
	move.b	L011,%%d2
	move.l	L012,%%d3
	move.b	(%%a1),%%d1
L0AD:
	add.b		%%d2,%%d4
	addx.l	%%d3,%%d5
	bcc.w		L0A8
	#picture width ?
	add.l		picturew,%%d5
L0A8:
	movea.l	%%d5,%%a0
	tst.b		(%%a0)
	beq.w		L0A9
	bset		%%d6,%%d1
	subq.b	#1,%%d6
	bpl.w		L0AA
	jmp			L01F
L0A9:
	#jmp L0A9								/* breakpoint */
	bclr		%%d6,%%d1
	#bset		%%d6,%%d1				/* For testing only */
	subq.b	#1,%%d6
	bpl.w		L0AA
L01F:
	#move.b	#0xff,%%d1            Testing purpose only
	move.b	%%d1,(%%a1)+
	move.b	#7,%%d6
	move.b	(%%a1),%%d1
	dbf			%%d7,L0AD
	jmp			L020
L0AA:
	dbf			%%d7,L0AD
L020:
	move.b	%%d1,(%%a1)							/* crash, cause a1=null */
L0A5:
	addi.l	#30,screen_cursor
L0A4:
	addq.w	#1,L013
	move.w	L01D,%%d0
	add.w		%%d0,L01C
	move.w	L016,%%d0
	add.w		%%d0,L015
	move.l	L019,%%d0
	add.l		%%d0,L017
	move.l	L01A,%%d0
	add.l		%%d0,L018
	jmp			draw_next_line_texture
end_draw_texture: /* L082: */
	movem.l	(%%a7)+,%%a6
	"
	: /* No ouputs */
	: [screen_buffer] "m" (screen_buffer)
		) ;
	unique_access_to_fill_triangle_with_texture = FALSE ;
}


void FillPolygonWithTexture (const Screen * screen, const Texture * t,
														 short nb,
														 const Coordinate coords [],
														 const Coordinate mappings []) {
	int i ;
	if (nb < 3) return ;
	for (i = 1 ; i < nb -1 ; i ++) {
		FillTriangleWithTexture (screen, t,
			&coords [0], &mappings [0],
			&coords [i], &mappings [i],
			&coords [i+1], &mappings [i+1]) ;
	}
}