// Header File
// !!! Do not Include this file !!!
// Created 19/06/2006; 20:19:06

/* inline */ void Transform (const Camera * camera, const Scene * scene) {
	// Variable declaration
	short t11, t12, t13, t21, t22, t23, t31, t32, t33 ;
	short zoomx, zoomy, focal ;
	long  rx, ry, rz ;
	short tx, ty, tz ;
	long  npoints, * points ;
	// Variable initialization
	rx = camera->rx ;
	ry = camera->ry ;
	rz = camera->rz ;
	tx = camera->tx ;
	ty = camera->ty ;
	tz = camera->tz ;
	zoomx = camera->zoomx ;
	zoomy = camera->zoomy ;
	focal = camera->focal ;
	npoints = scene->npoints ;
	points  = scene->points ;
	// TODO To optimize
	if (npoints <= 0) return ;
	// Core
	asm volatile ("
	move.l	%[sinus_table],%%a3		/* Loads the sinus table */
	move.l	%[rx],%%d0						/* Loads the sin(rx) into a0 */
	andi.l	#0x7F,%%d0
	asl.l	#1,%%d0
	add.l	%%a3,%%d0
	movea.l	%%d0,%%a0			
	move.l	%[ry],%%d0						/* Loads the sin(ry) into a1 */
	andi.l	#0x7F,%%d0			
	lsl.l	#1,%%d0			
	add.l	%%a3,%%d0			
	movea.l	%%d0,%%a1			
	move.l	%[rz],%%d0						/* Loads the sin(rz) into a2 */
	andi.l	#0x7F,%%d0			
	lsl.l	#1,%%d0			
	add.l	%%a3,%%d0			
	movea.l	%%d0,%%a2			
	moveq.l	#0,%%d2								/* Prepares registers */
	moveq.l	#0,%%d3			
	moveq.l	#0,%%d4			
	moveq.l	#0,%%d5			
	moveq.l	#0,%%d6			
	moveq.l	#0,%%d7			
	move.w	64(%%a0),%%d2					/* Calculates the transformation matrix */
	move.w	64(%%a1),%%d3
	move.w	64(%%a2),%%d4		
	move.w	(%%a0),%%d5
	move.w	(%%a1),%%d6			
	move.w	(%%a2),%%d7			
	move.l	%%d3,%%d0			
	muls.w	%%d4,%%d0			
	asr.l	#7,%%d0			
	move.w	%%d0,%[t11]
	move.l	%%d2,%%d1			
	muls.w	%%d7,%%d1			
	asr.l	#7,%%d1			
	move.l	%%d5,%%d0			
	muls.w	%%d6,%%d0			
	asr.l	#7,%%d0			
	muls.w	%%d4,%%d0			
	asr.l	#7,%%d0			
	sub.l	%%d1,%%d0			
	move.w	%%d0,%[t12]
	move.l	%%d5,%%d0			
	muls.w	%%d7,%%d0			
	asr.l	#7,%%d0			
	move.l	%%d2,%%d1			
	muls.w	%%d6,%%d1			
	asr.l	#7,%%d1			
	muls.w	%%d4,%%d1			
	asr.l	#7,%%d1			
	add.l	%%d0,%%d1			
	move.w	%%d1,%[t13]
	move.l	%%d3,%%d0			
	muls.w	%%d7,%%d0			
	asr.l	#7,%%d0			
	move.w	%%d0,%[t21]			
	move.l	%%d5,%%d0			
	muls.w	%%d6,%%d0			
	asr.l	#7,%%d0			
	muls.w	%%d7,%%d0			
	asr.l	#7,%%d0			
	move.l	%%d2,%%d1			
	muls.w	%%d4,%%d1			
	asr.l	#7,%%d1			
	add.l	%%d1,%%d0			
	move.w	%%d0,%[t22]
	move.l	%%d4,%%d0			
	muls.w	%%d5,%%d0			
	asr.l	#7,%%d0			
	move.l	%%d2,%%d1			
	muls.w	%%d6,%%d1			
	asr.l	#7,%%d1			
	muls.w	%%d7,%%d1			
	asr.l	#7,%%d1			
	sub.l	%%d0,%%d1			
	move.w	%%d1,%[t23]
	move.w	%%d6,%[t31]
	neg.w	%[t31]
	move.l	%%d5,%%d0			
	muls.w	%%d3,%%d0			
	asr.l	#7,%%d0			
	move.w	%%d0,%[t32]
	move.l	%%d2,%%d0			
	muls.w	%%d3,%%d0			
	asr.l	#7,%%d0			
	move.w	%%d0,%[t33]
	move.l	%[transformation_buffer],%%a1
	move.l	%[npoints],%%d7			
	subq.l	#1,%%d7
	move.l  %[points],%%a0
transform_point:
	move.l	(%%a0)+,%%d4		/* Loads the x original coordinate into d4 */
	move.l	(%%a0)+,%%d5		/* Loads the y original coordinate into d5 */
	move.l	(%%a0)+,%%d6		/* Loads the z original coordinate into d6 */
	move.l	%%d4,%%d1				/* Calculate the z coordinate:	*/
	muls.w	%[t31],%%d1		
	move.l	%%d5,%%d2			
	muls.w	%[t32],%%d2		
	move.l	%%d6,%%d3			
	muls.w	%[t33],%%d3		
	add.l	%%d1,%%d3			
	add.l	%%d2,%%d3
	muls.w	%[focal],%%d3		/* transforms to perspective */
	asr.l	#8,%%d3
	asr.l	#8,%%d3			
	sub.w	%[tz],%%d3		
	neg.w	%%d3
	move.l	%%d4,%%d1			/* Calculates the x coordinate */
	muls.w	%[t11],%%d1		
	move.l	%%d5,%%d2			
	muls.w	%[t12],%%d2		
	add.l	%%d2,%%d1			
	move.l	%%d6,%%d2			
	muls.w	%[t13],%%d2		
	add.l	%%d2,%%d1
	muls.w	%[zoomx],%%d1		/* Considers the x zoom */
	asr.l	#8,%%d1			
	divs.w  %%d3,%%d1				/* Considers the perspective */
	andi.l	#0xFFFF,%%d1		
	add.w	%[tx],%%d1				/* Final translation */
	move.w	%%d1,(%%a1)+		/* Stores the x coordinate */
	move.l	%%d4,%%d1				/* Calculates the y axis */
	muls.w	%[t21],%%d1		
	move.l	%%d5,%%d2			
	muls.w	%[t22],%%d2		
	add.l	%%d2,%%d1			
	move.l	%%d6,%%d2			
	muls.w	%[t23],%%d2		
	add.l	%%d2,%%d1			
	muls.w	%[zoomy],%%d1		/* Considers the y zoom */
	asr.l	#8,%%d1			
	divs.w %%d3,%%d1				/* Considers the perspective */
	andi.l	#0xFFFF,%%d1		
	neg.w	%%d1			
	add.w	%[ty],%%d1				/* Final y translation */
	move.w	%%d1,(%%a1)+		/* Stores the y coordinate */
	dbf	%%d7,transform_point	/* Transform next point */
	"
	: /* No outputs */
	: [t11] "g" (t11), [t12] "g" (t12), [t13] "g" (t13),
	  [t21] "g" (t21), [t22] "g" (t22), [t23] "g" (t23),
	  [t31] "g" (t31), [t32] "g" (t32), [t33] "g" (t33),
	  [transformation_buffer] "m" (transformation_buffer),
	  [rx] "g" (rx), [ry] "g" (ry), [rz] "g" (rz),
	  [tx] "g" (tx), [ty] "g" (ty), [tz] "g" (tz),
	  [focal] "g" (focal),[zoomx] "g" (zoomx),[zoomy] "g" (zoomy),
	  [sinus_table] "m" (sinus_table),
	  [npoints] "g" (npoints), [points] "m" (points)
	  ) ;
}
