// C Source File
// Created 29/06/2006; 12:24:23

#include "cubeScene.h"
#include "textureManager.h"

#define NB_POINTS 8
const long points [NB_POINTS][3] = {{10,10,10},
	{10,10,-10},
	{-10,10,-10},
	{-10,10,10},
	{10,-10,10},
	{10,-10,-10},
	{-10,-10,-10},
	{-10,-10,10}} ;
#define NB_CONNECTIONS 12
const short connections [NB_CONNECTIONS][2] =
 {{0,1},{1,2},{2,3},{3,0},{0,4},{4,5},{5,6},{6,7},{7,4},{7,3},{1,5},{6,2}} ;
#define NB_FACES 6
const short faces [NB_FACES][4] =
	{{2,1,5,6},{1,0,4,5},{2,3,0,1},{7,6,5,4},{3,2,6,7},{0,3,7,4}};

void FillPoints (const Scene * scene) {
	int i ;
  for (i = 0 ; i < NB_POINTS ; i++) {
  	AddPoint (scene, points [i][0], points [i][1], points [i][2]) ;
  }
}

void FillConnections (const Scene * scene) {
	int i ;
	for (i = 0 ; i < NB_CONNECTIONS ; i++) {
		AddConnection (scene, connections [i][0], connections [i][1]) ;
	}
}

void FillFaces (const Scene * scene) {
	int i ;
	for (i = 0 ; i < NB_FACES ; i++) {
		AddFace (scene, 4, (short []) {faces [i][0], faces [i][1], faces [i][2], faces [i][3]}) ;
	}
}

void FillDecoredFaces (const Scene * scene) {
	int i ;
	for (i = 0 ; i < NB_FACES ; i++) {
		AddDecoredFace (scene, &textures[i], 4,
			(short []){faces [i][0], faces [i][1], faces [i][2], faces [i][3]},
			mcoordinates[i]) ;
		/*AddDecoredFace (scene, &texture, 4,
			(short []){faces [i][0], faces [i][1], faces [i][2], faces [i][3]},
			mcoordinate) ;*/
	}	
}
