// Header File
// Created 28/06/2006; 16:57:49
#ifndef TEXTURE_MANAGER_H
#define TEXTURE_MANAGER_H

#include "cri3D.h"

#define NB_TEXTURES 6

#define AT_WIDTH 100
#define AT_HEIGHT 100

#define ABOUT_WIDTH 50
#define ABOUT_HEIGHT 50
#define ABOUT_MOVE_AXIS ry

#define BALL_WIDTH 50
#define BALL_HEIGHT 50
#define BALL_RADIUS 5
#define BALL_FRICTION_BIT_SHIFT 4
#define BALL_MOVE_AXIS rx

#define CUBE_WIDTH 48
#define CUBE_HEIGHT 48
#define CUBE_ROTATION_INCREMENT 3

#define DUCK_WIDTH 70
#define DUCK_HEIGHT 77

#define SPIRAL_WIDTH 100
#define SPIRAL_HEIGHT 97

#define ZOOM_WIDTH 100
#define ZOOM_HEIGHT 100
#define ZOOM_INCREMENT 5
#define ZOOM_DELTA_BIT_SHIFT 3
#define ZOOM_DELTA 28

#define ROTATION_CENTER_X 50
#define ROTATION_CENTER_Y 49
#define ROTATION_CIRCLE_RADIUS 50
// Optimized calculation for radius: 25 approximatly equal to 24 = 1 << 3 + 1 << 4
#define ROTATION_CIRCLE_RADIUS_FACTOR_1 4
#define ROTATION_CIRCLE_RADIUS_FACTOR_2 5
#define ROTATION_INCREMENT -10

const Texture texture ;

const Texture textures [NB_TEXTURES] ;

const Coordinates mcoordinate = {{0,0},{0,50},{50,50},{50,0}};

const Coordinate mcoordinates [NB_TEXTURES][4] =
	{{{0,ABOUT_HEIGHT},{ABOUT_WIDTH,ABOUT_HEIGHT},{ABOUT_WIDTH,0},{0,0}},
	 {{BALL_WIDTH,0},{0,0},{0,BALL_HEIGHT},{BALL_WIDTH,BALL_HEIGHT}},
	 {{0,0},{0,CUBE_HEIGHT},{CUBE_WIDTH,CUBE_HEIGHT},{CUBE_WIDTH,0}},
	 {{0,0},{0,DUCK_HEIGHT},{DUCK_WIDTH,DUCK_HEIGHT},{DUCK_WIDTH,0}},
	 {{0,0},{0,AT_HEIGHT},{AT_WIDTH,AT_HEIGHT},{AT_WIDTH,0}},
	 {{0,SPIRAL_HEIGHT / 2},{SPIRAL_WIDTH / 2, SPIRAL_HEIGHT}, {SPIRAL_WIDTH, SPIRAL_HEIGHT / 2}, {SPIRAL_WIDTH / 2,0}}};

void InitTextures () ;

void UpdateTextures (const Scene * scene, const Camera * camera) ;

void ReleaseTextures () ;

#endif